# to be run at 12:00, starting a new night PV voltage recording etc.

   F=$1.txt
   FN=${F/.txt/}
   Y=`date "+%y" -d $FN`
   M=`date "+%m" -d $FN`
   DA=`date "+%-d" -d $FN`
   DO=$[$DA-1]
   FD=${FN}d.txt

if `date -d "$FN" | grep CEST > /dev/null`  
 then  
  U=UT2
  UT="UTC+2h (CEST)"
 else
  U=UT1 
  UT="UTC+1h (CET)"
fi

if [ -a ${1}_m.txt ] 
then

BegR=`sed -rn '1{s/([-0-9A-Za-z:.]+ ){7}([0-9.]+) .*/\2/p}' ${FN}_m.txt`
#echo $BegR
EndR=`sed -rn '${s/([-0-9A-Za-z:.]+ ){7}([0-9.]+) .*/\2/p}' ${FN}_m.txt`
#echo $EndR
 if [ $BegR != $EndR ] 
 then 
 IncR=`calc -d "display(3); int(($EndR - $BegR)/3.48)" \
  | sed -n '${s/[[:blank:]]*/ /p}'`
# echo $IncR 
 else 
 IncR=0 
 fi

# works just for new .gnp since Aug 16, 2006
 if [ -a ${F/\.txt/_m.gnp} ] 
 then
 sed -r "
 /title 'temperature'/{s|$| \\
 'apdata.txt' using (3600*((\$1<12 ? 24 : 0) + \$1)+60*\$2+\$3):(\$4-1000) \\\ \\
   '%*11[^\\\n]%lf%*1[:]%lf%*1[:]%lf%*lf%*lf%*lf%*lf%*lf%*lf%lf' \\\ \\
   title '(pressure / 1 hPa) - 1000' with lines 11 , \\\ \\
 'apdata.txt' using (3600*((\$1<12 ? 24 : 0) + \$1)+60*\$2+\$3):(-\$4) \\\ \\
   '%*11[^\\\n]%lf%*1[:]%lf%*1[:]%lf%*lf%*lf%*lf%lf' \\\ \\
   title '- wind / 1 m/s' with impulses 12, \\\ \\
 'apdata.txt' using (3600*((\$1<12 ? 24 : 0) + \$1)+60*\$2+\$3):\\\ \\
   ((abs(\$4-180)<45 ? 1/0 : (\$4<180 ? \$4 : \$4 - 360)/45)) \\\ \\
   '%*11[^\\\n]%lf%*1[:]%lf%*1[:]%lf%*lf%*lf%*lf%*lf%lf' \\\ \\
   title 'wind dir / 45 degrees' with lines 13, \\\ \\
 'apdata.txt' using (3600*((\$1<12 ? 24 : 0) + \$1)+60*\$2+\$3):\\\ \\
   (abs(\$4-180)<45 ? (\$4 - 180)/45 : 1/0) \\\ \\
   '%*11[^\\\n]%lf%*1[:]%lf%*1[:]%lf%*lf%*lf%*lf%*lf%lf' \\\ \\
   title '(ev. wind dir - south)' with lines 14, \\\ \\ | } 
 "   ${F/\.txt/_m.gnp} >/tmp/night_mt1.gnp
sed "s/[[:blank:]]*$//" /tmp/night_mt1.gnp >/tmp/night_bas_mt.gnp
 else
 sed "1{i\
  Beg=$BegR
  }" night_ba_mpw.gnp >/tmp/night_bas_mt.gnp
 fi


LC_TIME=C

DN=`date "+%a %b %d" -d $FN`

 if (( $IncR \> 5 )) 
 then 
#echo "inserting 0.1 mm part"
sed -r "
/precipitation \/ 1 mm/{s|$|,\\\ \\
'${FN}_m.txt' using (3600*((\$1<12 ? 24 : 0) + \$1)+60*\$2+\$3):\\\ \\
 (0.1*(\$4-Beg)/3.48)\\\ \\
 \"%*11[^\\\n]%lf%*1[:]%lf%*1[:]%lf%*lf%*lf%*lf%*lf%*lf%lf\" \\\ \\
 title '' with lines 10| } " \
 /tmp/night_bas_mt.gnp >/tmp/night_mt2.gnp
sed "s/[[:blank:]]*$//" /tmp/night_mt2.gnp >/tmp/night_bas_mt.gnp
 fi




sed -r "/set term png size/{s/1151,863|831,623/160,120/}
 s/set grid .*/set grid/ 
 s/set out .*/set out 'night_mt.png'/
 /set key left/{i\
 set xlabel '' \\
 set ylabel '' \\
 set format x '' \\
 set format y '' \\
 set tmargin 1 \\
 set bmargin 0 \\
 set lmargin 0 \\
 set rmargin 0 \\
 set title '- $DN' offset 0,-1
 }
 /plot .*\[-18:36\]/{i\
 set format y2 '' 
 }
s/'(clear|Sun|precip|temp|dew|Celsius|PV|\(press|- wind|wind|\(ev.).*'/''/
s/'nold'/'$FD' index 1/ 
s/'nnew'/'$FD' index 2/ 
s/'m.txt'/'$FD' index 3/ 
s/'s.txt'/'$FD' index 0/ 
/'night.txt'/{N;d}
s/'apdata.txt'/'${FN}_m.txt'/ 
" \
 /tmp/night_bas_mt.gnp >/tmp/night_mt.gnp

 if [ -a $F.gz ]
 then 
  gzip -d $F.gz 
 fi


gnuplot /tmp/night_mt.gnp

#gzip $F

mv night_mt.png tiny/${FN}_m.png


else

# prior to meteo data storage


# before Aug 16, 2006
if [ -a ${F/\.txt/.gnp} ] 
then
# cat ${F/\.txt/.gnp} >/tmp/night_bas_mt.gnp
 cp ${F/txt/gnp} /tmp/night_bas.gnp
 sed  "/set out/{s/\(night|[0-9]{6}\)\.png/night_lg.png/}

5{i\
Ad               = 6.76001       \\
Bd               = 0.181864      \\
Cd               = 3.22308       \\
Dd               = 0.000125618   \\
Ed               = -1.09493e-06  \\
Di(x) = atan((x+Ad)*Bd)*Cd + Dd*(x**2) + Ed*(x**3)\\
# below -6:\\
An              = 7.84728       \\
Bn              = 0.283291      \\
Cn              = 1.52257       \\
Dn              = -0.00776427   \\
En              = -0.000215529  \\
Ni(x) = atan((x+An)*Bn)*Cn + Dn*(x**2) + En*(x**3)
}
   s/\$1>12/\$1>11/
   s/log10(\$7)/\$5>-6 ? Di(\$5) : Ni(\$5)/ 
   s/direct sun, ZE 15 cmag/clear sky sunlight/  
   s/log10(\$8)/(\$5>-6 ? Di(\$5) - (\$8 + 26.8)\/2.5 : (\$5>-20 ? Ni(\$5) -(\$8 + 26.8)\/2.5: 1\/0))/ 
   s/direct moon, ZE 15 cmag/clear sky moonlight/ " \
  /tmp/night_bas.gnp >/tmp/night_bas_mt.gnp 
else
 cat night_basic.gnp >/tmp/night_bas_mt.gnp
fi


LC_TIME=C

DN=`date "+%a %b %d" -d $FN`

sed -r "/set size/{s/(0.7|1.8)/0.25/}
 s/set grid .*/set grid/ 
 s/set out .*/set out 'night_mt.png'/
 s/UTC\+2h \(CEST\)/$UT/
 /^[[:blank:]]*plot/{i\
 set xlabel '' \\
 set ylabel '' \\
 set format x '' \\
 set format y '' \\
 set tmargin 1 \\
 set bmargin 0 \\
 set lmargin 0 \\
 set rmargin 0 \\
 set title '- $DN' ,-1
 }
 s/'(clear|Sun|PV).*'/''/
s/'nold'/'$FD' index 1/ 
s/'nnew'/'$FD' index 2/ 
s/'m.txt'/'$FD' index 3/ 
s/'s.txt'/'$FD' index 0/ 
s/'night.txt'/'$F'/ 
" \
 /tmp/night_bas_mt.gnp >/tmp/night_mt.gnp

 if [ -a $F.gz ]
 then 
  gzip -d $F.gz 
 fi


gnuplot /tmp/night_mt.gnp

#gzip $F

mv night_mt.png tiny/${FN}.png


fi
