# to be run at 12:00, starting a new night PV voltage recording etc.

cd /home/hollan/light/PV

#gnuplot night.gnp

D=`date '+%y%m%d'`


mv night.txt night.txt.obsolete
# -- a better possibility is be to create it again as a whole,
# at the end of the script

if [ -a night1.txt ] 
 then
  mv night1.txt $D.txt.full
 else 
  if [ -a night5.txt ] 
   then
    mv night5.txt $D.txt.full
   else 
    mv night3.txt $D.txt.full
  fi 
fi 
#mv night.png $D.png
BegR=`sed -rn '${s/([-0-9A-Za-z:.]+ ){7}([0-9.]+) .*/\2/p}' apdata.txt`
mv apdata.txt ${D}_m.txt

H=`date "+%-H"`
M=`date "+%-M"`
S=`date "+%-S"`

if (( $H \> 11 ))
then
 RS=`calc -d "(36*3600 - 25 - (3600*$H + 60*$M + $S))"`
else
 RS=`calc -d "(12*3600 - 25 - (3600*$H + 60*$M + $S))"`
fi 

echo $RS

/home/hollan/x/multimet_v.4.4s -6  -T $RS -i /dev/ttyUSB0 -o night5.txt &
sleep 5


 M=`date '+%y%m'`

 Y=`date '+%Y'`
 
if [ ! -d $M ]
then
 mkdir $M
fi 

DD=`date '+%d'`
echo "<A href=\"$M/${D}_m.png\"><IMG src=\"small/${D}_m.png\"
 ></A>&nbsp;<A href=\"$M/${D}_mpw.png\">$DD</A>" >>$M.htm

echo "<A href=\"$M/${D}_mpw.png\"><IMG src=\"tiny/${D}_m.png\"></A>" >> all.htm

LC_TIME=C

# making $D.txt anew, from $D.txt.full
if [ -a $D.txt.full ]
then
cat $D.txt.full | ~/bin/disc_samT ${D}_m.txt | \
 sed -r 's/([0-9]+) ([.0-9]+)([1-9])0+ /\1 \2\3 / ; s/ 0\.([0-9].*)/ .\1/' >$D.txt 
fi

HH=`sed -rn '1{s/.* ([0-2][0-9]):([0-9]{2}):([0-9]{2}) .*/\1/p}' $D.txt`
MM=`sed -rn '1{s/.* ([0-2][0-9]):([0-9]{2}):([0-9]{2}) .*/\2/p}' $D.txt`
SS=`sed -rn '1{s/.* ([0-2][0-9]):([0-9]{2}):([0-9]{2}) .*/\3/p}' $D.txt`

for F in final_large.sh final_large_m.sh final_lar_mpw.sh \
 finalRsmall.sh final_small_m.sh
do
 nbgnp=`sed -rn '/ night_ba/{s/.*( night_ba[a-z_]+)\.gnp.*/\1/p}' $F`
# sed -r "s/^U =.*/U = $HH*3600 + $MM*60 + $SS/" $nbgnp.gnp > /tmp/U.gnp
 sed -r "s/^U =.*/U = $HH*3600 + $MM*60 + $SS/
         s/f\(x\)/f(x,t)/ 
	 s/c\*/(c-0.05*((24-t)\/20))*/
	 s/3\.0\)/3.0,\$3)/ 
	 " $nbgnp.gnp > /tmp/U.gnp
 sed -r "/ night_ba/{s| (night_ba[a-z_]+)\.gnp | /tmp/U.gnp |}"  $F > /tmp/$F
 chmod +x /tmp/$F  
 /tmp/$F $D 
done

for F in final_tiny_mpw.sh
do
 nbgnp=`sed -rn '/ night_ba_/{s/.*( night_ba_[a-z_]+)\.gnp.*/\1/p}' $F`
 nbgn=`sed -rn '/ night_basic/{s/.*( night_basic)\.gnp.*/\1/p}' $F`
# sed -r "s/^U =.*/U = $HH*3600 + $MM*60 + $SS/" $nbgnp.gnp > /tmp/U.gnp
 sed -r "s/^U =.*/U = $HH*3600 + $MM*60 + $SS/
         s/f\(x\)/f(x,t)/ 
	 s/c\*/(c-0.05*((24-t)\/20))*/
	 s/3\.0\)/3.0,\$3)/ 
	 " $nbgnp.gnp > /tmp/U.gnp
 sed -r "s/^U =.*/U = $HH*3600 + $MM*60 + $SS/" $nbgn.gnp > /tmp/UU.gnp
 sed -r "/ night_ba_/{s| (night_ba_[a-z_]+)\.gnp | /tmp/U.gnp |}
         / night_basic/{s| (night_basic)\.gnp | /tmp/UU.gnp |}
	 "  $F > /tmp/$F
 chmod +x /tmp/$F  
 /tmp/$F $D 
done


if `date | grep CEST > /dev/null`  
 then  
  U=UT2
  UT="UTC+2h (CEST)"
 else
  U=UT1 
  UT="UTC+1h (CET)"
fi


DD=`date '+%-d'`
Dnew=$[$DD+1]

/home/hollan/bin/sol_heights $U -n0 >/tmp/nold

/home/hollan/bin/sol_heights -d$Dnew $U -n0 >/tmp/nnew

sed  "/^$Y/{s/$Y............../               5.9/}" /tmp/nold >nold
sed  "/^$Y/{s/$Y............../               5.9/}" /tmp/nnew >nnew

#/usr/local/bin/planet c10 t12 nb ne i n240 s0.1h ze15 >/tmp/m
/home/hollan/bin/planet3e c10 t12 $U nb ne k4 nr n240 s0.1h ze0 >/tmp/m

scp $M.htm all.htm jhollan@amper:www/light/luminance/PV
scp $D.png ${D}_m.png ${D}_mpw.png jhollan@amper:www/light/luminance/PV/$M


/usr/local/bin/planet c0 t12 $U nb nr ne i n240 s0.1h ze15 >/tmp/s

sed -n "/of the used time/  {N;  s/(.*) of the used time:\nMoon[ ]*// ;
 s/:/ /g; s/$Y-.*at //p} " /tmp/m >m.txt

sed -n "/of the used time/  {N;  s/(.*) of the used time:\nSUN[ ]*// ;
 s/:/ /g; s/$Y-.*at //p} " /tmp/s  >s.txt

sed "s/set term png size 1151,863/set term png size 831,623/
         s/f(x)/f(x,t)/ 
	 s/c\*/(c-0.05*((24-t)\/20))*/
	 s/3\.0)/3.0, \$3)/ 
 s/UTC+2h (CEST)/$UT/" night_basic.gnp >night.gnp
sed "1{i\
  Beg=$BegR
  } 
  s/set term png size 1151,863/set term png size 831,623/
         s/f(x)/f(x,t)/ 
	 s/c\*/(c-0.05*((24-t)\/20))*/
	 s/3\.0)/3.0, \$3)/ 
   s/UTC+2h (CEST)/$UT/" night_bas_m.gnp >night_m.gnp

sed "1{i\
  Beg=$BegR
  } 
  s/set term png size 1151,863/set term png size 831,623/
         s/f(x)/f(x,t)/ 
	 s/c\*/(c-0.05*((24-t)\/20))*/
	 s/3\.0)/3.0, \$3)/ 
   s/UTC+2h (CEST)/$UT/" night_ba_mpw.gnp >night_mpw.gnp

sed -r "1{i\
  Beg=$BegR
  } 
         s/f\(x\)/f(x,t)/ 
	 s/c\*/(c-0.05*((24-t)\/20))*/
	 s/3\.0\)/3.0, \$3)/ 
 s/ Kravi hora, Brno,//
   s/UTC\+2h \(CEST\)/$UT/
 s/[\"'](.*)from a PV panel.*[\"']$/\"\1up to \`date \"+%A %Y-%m-%d %H:%M\"\`\"/
 s/degrees and vice versa//
s/'Sun.* -18/'Sunset and Sun at -6, -12, -18/ 
" \
 night_bas_ms.gnp >night_ms.gnp

mv $D*.png $M
gzip $D.txt
gzip $D.txt.full
scp $D*.txt $D.txt.gz jhollan@amper:www/light/luminance/PV/$M
mv $D*.txt* $M

cd small
scp $D.png ${D}_m.png jhollan@amper:www/light/luminance/PV/small

cd ../tiny
scp ${D}_m.png jhollan@amper:www/light/luminance/PV/tiny

D=night5
echo $D
HH=`sed -rn '1{s/.* ([0-2][0-9]):([0-9]{2}):([0-9]{2}) .*/\1/p}' $D.txt`
MM=`sed -rn '1{s/.* ([0-2][0-9]):([0-9]{2}):([0-9]{2}) .*/\2/p}' $D.txt`
SS=`sed -rn '1{s/.* ([0-2][0-9]):([0-9]{2}):([0-9]{2}) .*/\3/p}' $D.txt`

echo 'PV data start at' $HH:$MM:$SS

for F in night_mpw.gnp night.gnp night_ms.gnp night_m.gnp
do
 if (( $HH \> 11 ))
  then
   sed -r "s/^U =.*/U = $HH*3600 + $MM*60 + $SS/" $F > ${F}.gn
 else
   sed -r "s/^U =.*/U = ($HH+24)*3600 + $MM*60 + $SS/" $F > ${F}.gn
 fi
 mv ${F}.gn $F
done
